.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm		; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
	buffersize		= 20000					; don't go higher than 100000, ml.exe would slow down
	LOOP_COUNT	= 1000000

.data
MyString	db "This is a useless string", 0

.data?
align 16
src16	db 1, 2, 3, 4, 5, 6, 7		; try adding 8, then 9
src	dd buffersize dup(?)
align 16
dest16	db 1, 2, 3, 4, 5, 6, 7, 9		; try adding 8, then 9
dest	dd buffersize dup(?)

.code
start:
	REPEAT 100
	invoke lstrcat, addr src, chr$("This is a test..")
	ENDM
	REPEAT 5

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		ffree st(7)
		REPEAT 200
			fild qword ptr [esi]
			fistp qword ptr [edi]
			lea esi, [esi+8]
			lea edi, [edi+8]
		ENDM
	counter_end
	print str$(eax), 9, "cycles for fild/fistp", 13, 10

;	print offset dest, 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src16
		mov edi, offset dest16
		REPEAT 100
			movdqa xmm1, [esi]
			movdqa [edi], xmm1
			lea esi, [esi+16]
			lea edi, [edi+16]
		ENDM
	counter_end
	print str$(eax), 9, "cycles for movdqa (aligned 16)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src16
		mov edi, offset dest16
		mov ecx, 400
		rep movsd
	counter_end
	print str$(eax), 9, "cycles for rep movsd (aligned 16)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		REPEAT 100
			movdqu xmm1, [esi]
			movdqu [edi], xmm1
			lea esi, [esi+16]
			lea edi, [edi+16]
		ENDM
	counter_end
	print str$(eax), 9, "cycles for movdqu", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		REPEAT 100
			movlps xmm0, QWORD PTR [esi]
			movhps xmm0, QWORD PTR [esi+8]
			movlps QWORD PTR [esi], xmm0
			movhps QWORD PTR [esi+8], xmm0
			lea esi, [esi+16]
			lea edi, [edi+16]
		ENDM
	counter_end
	print str$(eax), 9, "cycles for movlps/movhps", 13, 10, 10

	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit
end start

RichMasm options:
OxPT_Linker	link	; If present in \bin, PoLink.exe will be used; delete the x to force link.exe
OxPT_Assembler	ml	; If present in \bin, JWasm.exe will be used; delete the x to force link.exe
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_NoWarn	LNK4254, multiple	; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OPT_WAIT	0		; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
